<?php

namespace Intergo\SubscriptionClient;

use Intergo\BaseClient\ApiHandler;
use Intergo\BaseClient\Enums\HttpMethodEnum;

class SubscriptionApiHandler extends ApiHandler
{
    protected static $endpoints = [
        //Plans
        'getPlans' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/plans'],
        'getPlanById' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/plans/:id'],
        'createPlan' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/plans/create'],
        'updatePlan' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/plans/:id/update'],
        'deletePlan' => [self::METHOD => HttpMethodEnum::DELETE, self::URL => '/plan/:id/delete'],
        'getPlansByIds' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/plans/ids', self::INTERNAL => true],

        // Plan Types
        'getPlanTypes' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/plan-types'],
        'getPlanTypeById' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/plan-types/:id'],
        'createPlanType' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/plan-types/create'],
        'updatePlanType' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/plan-types/:id/update'],
        'deletePlanType' => [self::METHOD => HttpMethodEnum::DELETE, self::URL => '/plan-types/:id/delete'],

        //Subscriptions
        'getSubscriptionsForManager' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/subscriptions', self::INTERNAL => true],
        'storeSubscription' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/subscriptions/create', self::INTERNAL => true],
        'getSubscriptionById' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/subscriptions/:id'],
        'getSubscriptionBillingLogsBasedOnSubscriptionId' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/subscriptions/:id/logs'],
    ];
}
